import logging
import threading

from fischertechnik.controller.Motor import Motor
from lib.Axes1Ref import *
from lib.controller import *


rv1 = None
rv2 = None
rv3 = None
poslist = None
av1 = None
av2 = None
av3 = None
name = None
lockVGR = None
abspos_VGR = None
temp = None


def get_lock_VGR():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE0_VGR, '-')
    return lockVGR


def init_VGR():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '-')
    lockVGR = threading.RLock() #https://stackoverflow.com/questions/28017535/do-i-have-to-lock-all-functions-that-calls-to-one-or-more-locked-function-for-mu
    moveRef_VGR_S231()


def log_abspos_VGR():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '-')
    abspos_VGR = (get_abspos())[ : 3]
    if abspos_VGR[ : 1] == None or abspos_VGR[ : 2] == None or abspos_VGR[ : 3] == None:
        logging.log(logging.DEBUG_VGR, 'abspos_VGR=None')
    else:
        logging.log(logging.DEBUG_VGR, 'abspos_VGR=%d %d %d', abspos_VGR[0], abspos_VGR[1], abspos_VGR[2])


def stop_VGR():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '-')
    lockVGR.acquire()
    TXT_VGR_M_M1_encodermotor.stop_sync()
    TXT_VGR_M_M2_encodermotor.stop_sync()
    TXT_VGR_M_M3_encodermotor.stop_sync()
    lockVGR.release()


def moveRef_VGR_P123():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '->')
    lockVGR.acquire()
    th1 = threading.Thread(target=moveRef, args=(1, ), daemon=True)
    th2 = threading.Thread(target=moveRef, args=(2, ), daemon=True)
    th3 = threading.Thread(target=moveRef, args=(3, ), daemon=True)
    th1.start()
    th2.start()
    th3.start()
    th1.join()
    th2.join()
    th3.join()
    lockVGR.release()
    logging.log(logging.TRACE_VGR, '<-')


def moveRef_VGR_S231():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '->')
    lockVGR.acquire()
    moveRef(2)
    moveRef(3)
    moveRef(1)
    lockVGR.release()
    logging.log(logging.TRACE_VGR, '<-')


def moveRef_VGR_S23():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, '->')
    lockVGR.acquire()
    moveRef(2)
    moveRef(3)
    lockVGR.release()
    logging.log(logging.TRACE_VGR, '<-')


def moveRel_VGR_P123(rv1, rv2, rv3):
    global poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'rv=%d %d %d', rv1, rv2, rv3)
    lockVGR.acquire()
    th1 = threading.Thread(target=moveRel, args=(1,rv1, ), daemon=True)
    th2 = threading.Thread(target=moveRel, args=(2,rv2, ), daemon=True)
    th3 = threading.Thread(target=moveRel, args=(3,rv3, ), daemon=True)
    th1.start()
    th2.start()
    th3.start()
    th1.join()
    th2.join()
    th3.join()
    log_abspos_VGR()
    lockVGR.release()


def moveRel_VGR_P123_list(poslist):
    global rv1, rv2, rv3, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'poslist=%d %d %d', poslist[0], poslist[1], poslist[2])
    moveRel_VGR_P123(poslist[0], poslist[1], poslist[2])


def moveRel_VGR_S123(rv1, rv2, rv3):
    global poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'rv=%d %d %d', rv1, rv2, rv3)
    lockVGR.acquire()
    moveRel(1, rv1)
    moveRel(2, rv2)
    moveRel(3, rv3)
    log_abspos_VGR()
    lockVGR.release()


def moveRel_VGR_S123_list(poslist):
    global rv1, rv2, rv3, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'poslist=%d %d %d', poslist[0], poslist[1], poslist[2])
    moveRel_VGR_S123(poslist[0], poslist[1], poslist[2])


def moveAbs_VGR_P123(av1, av2, av3):
    global rv1, rv2, rv3, poslist, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'av=%d %d %d', av1, av2, av3)
    lockVGR.acquire()
    th1 = threading.Thread(target=moveAbs, args=(1,av1, ), daemon=True)
    th2 = threading.Thread(target=moveAbs, args=(2,av2, ), daemon=True)
    th3 = threading.Thread(target=moveAbs, args=(3,av3, ), daemon=True)
    th1.start()
    th2.start()
    th3.start()
    th1.join()
    th2.join()
    th3.join()
    log_abspos_VGR()
    lockVGR.release()


def moveAbs_VGR_P123_list(poslist):
    global rv1, rv2, rv3, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'poslist=%d %d %d', poslist[0], poslist[1], poslist[2])
    moveAbs_VGR_P123(poslist[0], poslist[1], poslist[2])


def moveAbs_VGR_P123_name(name):
    global rv1, rv2, rv3, poslist, av1, av2, av3, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'name=%s', name)
    if name != None:
        temp = name
        if temp != None and len(temp) == 3:
            moveAbs_VGR_P123_list(temp)


def moveAbs_VGR_S123(av1, av2, av3):
    global rv1, rv2, rv3, poslist, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'av=%d %d %d', av1, av2, av3)
    lockVGR.acquire()
    moveAbs(1, av1)
    moveAbs(2, av2)
    moveAbs(3, av3)
    log_abspos_VGR()
    lockVGR.release()


def moveAbs_VGR_S123_list(poslist):
    global rv1, rv2, rv3, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    logging.log(logging.TRACE_VGR, 'poslist=%d %d %d', poslist[0], poslist[1], poslist[2])
    moveAbs_VGR_S123(poslist[0], poslist[1], poslist[2])


def get_abspos_VGR():
    global rv1, rv2, rv3, poslist, av1, av2, av3, name, lockVGR, abspos_VGR, temp
    return (get_abspos())[ : 3]


